# -*- encoding: utf-8 -*-
# stub: wavefile 1.1.2 ruby lib

Gem::Specification.new do |s|
  s.name = "wavefile".freeze
  s.version = "1.1.2"

  s.required_rubygems_version = Gem::Requirement.new(">= 0".freeze) if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib".freeze]
  s.authors = ["Joel Strait".freeze]
  s.date = "2024-02-22"
  s.description = "You can use this gem to create Ruby programs that work with audio, by reading and writing Wave sound files (*.wav). Since it is written in pure Ruby (as opposed to wrapping an existing C library), you can use it without having to compile a separate extension.".freeze
  s.email = "joel dot strait at Google's popular web mail service".freeze
  s.files = ["LICENSE".freeze, "README.markdown".freeze, "Rakefile".freeze, "lib/wavefile.rb".freeze, "lib/wavefile/buffer.rb".freeze, "lib/wavefile/chunk_readers.rb".freeze, "lib/wavefile/chunk_readers/base_chunk_reader.rb".freeze, "lib/wavefile/chunk_readers/data_chunk_reader.rb".freeze, "lib/wavefile/chunk_readers/format_chunk_reader.rb".freeze, "lib/wavefile/chunk_readers/riff_reader.rb".freeze, "lib/wavefile/chunk_readers/sample_chunk_reader.rb".freeze, "lib/wavefile/duration.rb".freeze, "lib/wavefile/format.rb".freeze, "lib/wavefile/reader.rb".freeze, "lib/wavefile/sampler_info.rb".freeze, "lib/wavefile/sampler_loop.rb".freeze, "lib/wavefile/smpte_timecode.rb".freeze, "lib/wavefile/unvalidated_format.rb".freeze, "lib/wavefile/writer.rb".freeze, "test/buffer_test.rb".freeze, "test/chunk_readers/format_chunk_reader_test.rb".freeze, "test/duration_test.rb".freeze, "test/fixtures/wave/invalid/bad_riff_header.wav".freeze, "test/fixtures/wave/invalid/bad_wavefile_format.wav".freeze, "test/fixtures/wave/invalid/data_chunk_ends_after_chunk_id.wav".freeze, "test/fixtures/wave/invalid/data_chunk_has_incomplete_chunk_size.wav".freeze, "test/fixtures/wave/invalid/data_chunk_truncated.wav".freeze, "test/fixtures/wave/invalid/empty.wav".freeze, "test/fixtures/wave/invalid/empty_format_chunk.wav".freeze, "test/fixtures/wave/invalid/extensible_format_chunk_extension_incomplete.wav".freeze, "test/fixtures/wave/invalid/extensible_format_chunk_extension_incomplete_in_incorrectly_sized_chunk.wav".freeze, "test/fixtures/wave/invalid/extensible_format_chunk_extension_incomplete_in_large_enough_chunk.wav".freeze, "test/fixtures/wave/invalid/extensible_format_chunk_extension_missing.wav".freeze, "test/fixtures/wave/invalid/extensible_format_chunk_extension_size_incomplete.wav".freeze, "test/fixtures/wave/invalid/extensible_format_chunk_extension_size_incomplete_with_padding_byte.wav".freeze, "test/fixtures/wave/invalid/extensible_format_chunk_extension_truncated.wav".freeze, "test/fixtures/wave/invalid/extensible_format_chunk_oversized_extension_too_large.wav".freeze, "test/fixtures/wave/invalid/float_format_chunk_extension_size_incomplete.wav".freeze, "test/fixtures/wave/invalid/float_format_chunk_extension_size_incomplete_with_padding_byte.wav".freeze, "test/fixtures/wave/invalid/float_format_chunk_oversized_extension_too_large.wav".freeze, "test/fixtures/wave/invalid/format_chunk_after_data_chunk.wav".freeze, "test/fixtures/wave/invalid/format_chunk_extra_bytes_with_odd_size_and_missing_padding_byte.wav".freeze, "test/fixtures/wave/invalid/format_chunk_with_extra_byte_and_missing_padding_byte.wav".freeze, "test/fixtures/wave/invalid/incomplete_riff_format.wav".freeze, "test/fixtures/wave/invalid/incomplete_riff_header.wav".freeze, "test/fixtures/wave/invalid/insufficient_format_chunk.wav".freeze, "test/fixtures/wave/invalid/no_data_chunk.wav".freeze, "test/fixtures/wave/invalid/no_format_chunk.wav".freeze, "test/fixtures/wave/invalid/no_format_chunk_size.wav".freeze, "test/fixtures/wave/invalid/no_riff_format.wav".freeze, "test/fixtures/wave/invalid/riff_chunk_has_incomplete_chunk_size.wav".freeze, "test/fixtures/wave/invalid/smpl_chunk_empty.wav".freeze, "test/fixtures/wave/invalid/smpl_chunk_fields_out_of_range.wav".freeze, "test/fixtures/wave/invalid/smpl_chunk_loop_count_too_high.wav".freeze, "test/fixtures/wave/invalid/smpl_chunk_truncated_sampler_specific_data.wav".freeze, "test/fixtures/wave/invalid/truncated_smpl_chunk.wav".freeze, "test/fixtures/wave/invalid/unsupported_format_extension_size_incomplete.wav".freeze, "test/fixtures/wave/invalid/unsupported_format_extension_size_incomplete_with_padding_byte.wav".freeze, "test/fixtures/wave/invalid/unsupported_format_extension_truncated.wav".freeze, "test/fixtures/wave/invalid/unsupported_format_oversized_extension_too_large.wav".freeze, "test/fixtures/wave/unsupported/bad_channel_count.wav".freeze, "test/fixtures/wave/unsupported/bad_sample_rate.wav".freeze, "test/fixtures/wave/unsupported/extensible_container_size_bigger_than_sample_size.wav".freeze, "test/fixtures/wave/unsupported/extensible_unsupported_subformat_guid.wav".freeze, "test/fixtures/wave/unsupported/unsupported_audio_format.wav".freeze, "test/fixtures/wave/unsupported/unsupported_bits_per_sample.wav".freeze, "test/fixtures/wave/unsupported/unsupported_format_code_missing_extension_size.wav".freeze, "test/fixtures/wave/unsupported/unsupported_format_code_with_extension.wav".freeze, "test/fixtures/wave/unsupported/unsupported_format_code_with_extension_and_extra_bytes.wav".freeze, "test/fixtures/wave/unsupported/unsupported_format_code_with_incomplete_extension.wav".freeze, "test/fixtures/wave/unsupported/unsupported_format_code_with_oversized_extension.wav".freeze, "test/fixtures/wave/unsupported/unsupported_format_code_with_oversized_extension_and_extra_bytes.wav".freeze, "test/fixtures/wave/valid/no_samples.wav".freeze, "test/fixtures/wave/valid/valid_extensible_20_pcm_16_44100_speaker_mapping_overflow.wav".freeze, "test/fixtures/wave/valid/valid_extensible_format_chunk_oversized_extension.wav".freeze, "test/fixtures/wave/valid/valid_extensible_format_chunk_oversized_extension_and_extra_bytes.wav".freeze, "test/fixtures/wave/valid/valid_extensible_format_chunk_with_extra_bytes.wav".freeze, "test/fixtures/wave/valid/valid_extensible_mono_float_32_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_mono_float_64_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_mono_pcm_16_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_mono_pcm_16_44100_non_default_speaker_mapping.wav".freeze, "test/fixtures/wave/valid/valid_extensible_mono_pcm_24_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_mono_pcm_32_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_mono_pcm_8_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_stereo_float_32_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_stereo_float_64_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_stereo_pcm_16_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_stereo_pcm_16_44100_center_right_speakers.wav".freeze, "test/fixtures/wave/valid/valid_extensible_stereo_pcm_16_44100_more_speakers_than_channels.wav".freeze, "test/fixtures/wave/valid/valid_extensible_stereo_pcm_16_44100_more_speakers_than_defined_by_spec.wav".freeze, "test/fixtures/wave/valid/valid_extensible_stereo_pcm_16_44100_only_undefined_high_bit_speakers.wav".freeze, "test/fixtures/wave/valid/valid_extensible_stereo_pcm_24_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_stereo_pcm_24_44100_incomplete_speaker_mapping.wav".freeze, "test/fixtures/wave/valid/valid_extensible_stereo_pcm_24_44100_no_speaker_mapping.wav".freeze, "test/fixtures/wave/valid/valid_extensible_stereo_pcm_32_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_stereo_pcm_8_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_tri_float_32_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_tri_float_64_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_tri_pcm_16_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_tri_pcm_16_44100_custom_speaker_mapping.wav".freeze, "test/fixtures/wave/valid/valid_extensible_tri_pcm_24_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_tri_pcm_32_44100.wav".freeze, "test/fixtures/wave/valid/valid_extensible_tri_pcm_8_44100.wav".freeze, "test/fixtures/wave/valid/valid_float_format_chunk_missing_extension_size.wav".freeze, "test/fixtures/wave/valid/valid_float_format_chunk_oversized_extension.wav".freeze, "test/fixtures/wave/valid/valid_float_format_chunk_oversized_extension_and_extra_bytes.wav".freeze, "test/fixtures/wave/valid/valid_float_format_chunk_with_extra_bytes.wav".freeze, "test/fixtures/wave/valid/valid_format_chunk_extra_bytes_with_odd_size_and_padding_byte.wav".freeze, "test/fixtures/wave/valid/valid_format_chunk_with_extra_byte_and_padding_byte.wav".freeze, "test/fixtures/wave/valid/valid_format_chunk_with_extra_bytes.wav".freeze, "test/fixtures/wave/valid/valid_mono_float_32_44100.wav".freeze, "test/fixtures/wave/valid/valid_mono_float_64_44100.wav".freeze, "test/fixtures/wave/valid/valid_mono_pcm_16_44100.wav".freeze, "test/fixtures/wave/valid/valid_mono_pcm_16_44100_junk_chunk_final_chunk_missing_padding_byte.wav".freeze, "test/fixtures/wave/valid/valid_mono_pcm_16_44100_junk_chunk_with_padding_byte.wav".freeze, "test/fixtures/wave/valid/valid_mono_pcm_16_44100_with_extension.wav".freeze, "test/fixtures/wave/valid/valid_mono_pcm_24_44100.wav".freeze, "test/fixtures/wave/valid/valid_mono_pcm_32_44100.wav".freeze, "test/fixtures/wave/valid/valid_mono_pcm_8_44100.wav".freeze, "test/fixtures/wave/valid/valid_mono_pcm_8_44100_with_padding_byte.wav".freeze, "test/fixtures/wave/valid/valid_stereo_float_32_44100.wav".freeze, "test/fixtures/wave/valid/valid_stereo_float_64_44100.wav".freeze, "test/fixtures/wave/valid/valid_stereo_pcm_16_44100.wav".freeze, "test/fixtures/wave/valid/valid_stereo_pcm_24_44100.wav".freeze, "test/fixtures/wave/valid/valid_stereo_pcm_32_44100.wav".freeze, "test/fixtures/wave/valid/valid_stereo_pcm_8_44100.wav".freeze, "test/fixtures/wave/valid/valid_tri_float_32_44100.wav".freeze, "test/fixtures/wave/valid/valid_tri_float_64_44100.wav".freeze, "test/fixtures/wave/valid/valid_tri_pcm_16_44100.wav".freeze, "test/fixtures/wave/valid/valid_tri_pcm_24_44100.wav".freeze, "test/fixtures/wave/valid/valid_tri_pcm_32_44100.wav".freeze, "test/fixtures/wave/valid/valid_tri_pcm_8_44100.wav".freeze, "test/fixtures/wave/valid/valid_with_sample_chunk_after_data_chunk.wav".freeze, "test/fixtures/wave/valid/valid_with_sample_chunk_after_data_chunk_and_data_chunk_has_padding_byte.wav".freeze, "test/fixtures/wave/valid/valid_with_sample_chunk_before_data_chunk.wav".freeze, "test/fixtures/wave/valid/valid_with_sample_chunk_no_loops.wav".freeze, "test/fixtures/wave/valid/valid_with_sample_chunk_with_extra_unused_bytes.wav".freeze, "test/fixtures/wave/valid/valid_with_sample_chunk_with_sampler_specific_data.wav".freeze, "test/format_test.rb".freeze, "test/reader_test.rb".freeze, "test/sampler_info_test.rb".freeze, "test/sampler_loop_test.rb".freeze, "test/smpte_timecode_test.rb".freeze, "test/unvalidated_format_test.rb".freeze, "test/wavefile_io_test_helper.rb".freeze, "test/writer_test.rb".freeze]
  s.homepage = "https://wavefilegem.com/".freeze
  s.licenses = ["MIT".freeze]
  s.post_install_message = "Thanks for installing the WaveFile gem! For documentation and examples, visit https://wavefilegem.com".freeze
  s.required_ruby_version = Gem::Requirement.new(">= 2.0".freeze)
  s.rubygems_version = "3.4.20".freeze
  s.summary = "A pure Ruby library for reading and writing Wave sound files (*.wav)".freeze
end
